function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useMemo } from "react";
import { useAddonState, useChannel, useParameter } from "@storybook/api";
import { AddonPanel } from "@storybook/components";
import { ADDON_ID, EVENTS, PARAM_KEY } from "./constants";
import { PanelContent } from "./components/PanelContent";
import { format as prettierFormat } from "prettier/standalone";
import prettierHtml from "prettier/parser-html";
export var Panel = function Panel(props) {
  // https://storybook.js.org/docs/react/addons/addons-api#useaddonstate
  var _useAddonState = useAddonState(ADDON_ID, {
    code: null,
    options: {}
  }),
      _useAddonState2 = _slicedToArray(_useAddonState, 2),
      code = _useAddonState2[0].code,
      setState = _useAddonState2[1]; // https://storybook.js.org/docs/react/addons/addons-api#usechannel


  useChannel(_defineProperty({}, EVENTS.CODE_UPDATE, function (_ref) {
    var code = _ref.code;
    return setState(function (state) {
      return _objectSpread(_objectSpread({}, state), {}, {
        code: code
      });
    });
  }));
  var parameters = useParameter(PARAM_KEY, {});
  var _parameters$highlight = parameters.highlighter;
  _parameters$highlight = _parameters$highlight === void 0 ? {} : _parameters$highlight;
  var _parameters$highlight2 = _parameters$highlight.showLineNumbers,
      showLineNumbers = _parameters$highlight2 === void 0 ? false : _parameters$highlight2,
      _parameters$highlight3 = _parameters$highlight.wrapLines,
      wrapLines = _parameters$highlight3 === void 0 ? true : _parameters$highlight3,
      _parameters$prettier = parameters.prettier,
      prettier = _parameters$prettier === void 0 ? {} : _parameters$prettier;

  var prettierConfig = _objectSpread(_objectSpread({
    htmlWhitespaceSensitivity: "ignore"
  }, prettier), {}, {
    // Ensure we always pick the html parser
    parser: "html",
    plugins: [prettierHtml]
  });

  var formattedCode = useMemo(function () {
    return code && prettierFormat(code, prettierConfig);
  }, [code, prettierConfig]);
  return /*#__PURE__*/React.createElement(AddonPanel, props, /*#__PURE__*/React.createElement(PanelContent, {
    code: formattedCode,
    showLineNumbers: showLineNumbers,
    wrapLines: wrapLines
  }));
};